addpath('../data/graphs/');
addpath('../data/shapes/');
addpath('../external/');

% Name of the graph to load
graph_name = 'graph2';

% Load the edges of the graph
E = load([graph_name '_edges.txt']);

% Load the x,y of the nodes of the graph
C = load([graph_name '_coordinates.txt']);

plot_graph(E, C(:,1), C(:,2));

%% To complete:
% Use spectral clustering to construct a vector of size nv x 1, whose
% ith element represents which cluster (segment) the node i belongs to.
% First you'll need to construct the Laplacian matrix, then compute its
% smallest eigenvalue/vector and then cluster according to the values in
% the vector.

% To compute the eigenvectors/values, please use the Matlab function eigs
% Namely, once you have the Laplacian matrix L, you can use:
% [v,e] = eigs(L, 5, -1e-5);
% to construct the first 5 eigenvectors of L. The last parameter '-1e-5'
% is there to make sure that you get the first 5 eigenvectors, closest to
% 0.

% Note that once you have the eigenvectors, you can simply use the function
% kmeans in MATLAB to compute the clusters. Namely, you can use:
% clusters = kmeans(v, num_clusters);


plot_graph_wfunction(E, C(:,1), C(:,2), clusters);
