clear all;
close all;
addpath('../data/graphs/');
addpath('../data/shapes/');
addpath('../external/');

% Name of the shape to load
shape_name = 'armadillo-deform1';

% Load the triangle mesh
S = read_off_shape([shape_name '.off']);

% Plot the initial shape
plot_mesh(S.surface);
view([-180 -90]);
fprintf('Press any key to continue\n');
pause;

%% To complete:
% Use spectral clustering to construct a vector of size nv x 1, whose
% ith element represents which cluster (segment) the node i belongs to.
% First you'll need to construct the Laplacian matrix, then compute its
% smallest eigenvalue/vectors and then cluster according to the values in
% those vectors.

% For shapes you are expected to construct the cotangent Laplacian, given
% as L = A^{-1} W, where A is the diagonal matrix of area weights, and W
% is a sparse matrix, such that W_ij = (cot(a) + cot(b))/2 as shown during
% the lecture.

% To compute the eigenvectors/values, please use the Matlab function eigs
% Namely, once you have the matrices A and W, you can use:
% [v,e] = eigs(W, A, 5, -1e-5);
% to construct the first 5 eigenvectors of L. The last parameter '-1e-5'
% is there to make sure that you get the first 5 eigenvectors, closest to
% 0.

% Note that once you have the eigenvectors, you can simply use the function
% kmeans in MATLAB to compute the clusters. Namely, you can use:
% clusters = kmeans(v, num_clusters);

plot_mesh_wf(S.surface, clusters);
view([-180 -90]);
